#pragma once

namespace ModelParser {

class Data
{
public:
	Data();
	~Data();

	bool Parse(const std::string& line, unsigned int linenr);

	void WriteHeader(std::ofstream& ofs) const;
	void WriteSource(std::ofstream& ofs, std::string class_name) const;

	inline const std::string& GetName() const { return Name; }
	inline size_t GetNumVariables() const { return Variables.size(); }
	inline size_t GetNumObservations() const { return Observations.size(); }
	inline const std::string& GetVariableName(size_t i) const { return Variables[i]; }
	inline const std::string& GetObservationName(size_t i) const { return Observations[i]; }

	bool GetVariableIndex(const std::string& varname, size_t& ix) const;

private:
	std::string Name;
	std::string Filename;
	std::vector<std::string> Variables;
	std::vector<std::string> Observations;

	MatrixReal Values;
};

}
