#pragma once

#include "NestedSamplingStrategy.h"

namespace bcm {

class Prior;

class NestedSamplingStrategyMCMC : public NestedSamplingStrategy
{
public:
	NestedSamplingStrategyMCMC(SamplerNested* sampler, size_t numsteps);
	virtual ~NestedSamplingStrategyMCMC();
	
	virtual bool Initialize(Real prior_volume_estimate, RNG* rng);
	virtual bool UpdateRemoveSample(const Sample* removed_sample, Real prior_volume_estimate, bool& reset, RNG* rng);
	virtual bool GetNewSample(Real min_llh, Sample* sample, RNG* rng, size_t threadix) const;

private:
	// Settings
	size_t steps;

	// Run-time variables
	VectorReal empirical_mean;
	VectorReal empirical_variance;
	VectorReal proposal_sigma;
	size_t removed_ix;
	mutable Real proposal_scale;
	mutable Real current_acceptance_rate_ema;
};

}
