#pragma once

#include "RNG.h"

namespace bcm {

class Prior;

namespace NestedSamplingUtils {

bool ConvertToUnitSpace(const VectorReal& original, VectorReal& unit, const Prior* prior);
bool ConvertToOriginalSpace(const VectorReal& unit, VectorReal& original, const Prior* prior);
void EigenDecomposition(const MatrixReal& covariance, MatrixReal& eigval, MatrixReal& eigvec, MatrixReal& inv_covariance);

void GeneratePointInUnitSphere(VectorReal& sample, RNG* rng);
Real EuclideanDistanceSq(const VectorReal& p1, const VectorReal& p2);
Real MahalanobisDistance(const VectorReal& p, const MatrixReal& inv_covariance, const VectorReal& center, const Real scale);
Real MahalanobisDistanceSqFast(const VectorReal& p, const MatrixReal& inv_covariance, const VectorReal& center, const Real scale, VectorReal& tmp1, VectorReal& tmp2);
bool PointInEllipsoid(const VectorReal& p, const MatrixReal& inv_covariance, const VectorReal& center, const Real scale);
bool PointInEllipsoidFast(const VectorReal& p, const MatrixReal& inv_covariance, const VectorReal& center, const Real scale, VectorReal& tmp1, VectorReal& tmp2);

}
}
