#pragma once

namespace bcm {

class VariableSet;

class OutputValueHandlerFileDumper
{
public:
	OutputValueHandlerFileDumper(size_t buffer_size = 100);
	~OutputValueHandlerFileDumper();

	void SetFile(const std::string& filename);
	void SetNumValues(size_t n);
	bool Initialize();
	void Handle(const Real* values, void*);

	boost::function<void (const Real* values, void* user)> GetFunctionPointer();

private:
	void Flush();

	std::string filename;
	bool binary;
	size_t num_values;
	bool Initialized;
	
	std::vector<VectorReal> output_buffer;
	size_t output_buffer_ix;
};

}
