#pragma once

#include "PriorMarginalGMM.h"

namespace bcm {

class BivariateGMM;

class PriorBivariateMarginalGMM : public PriorMarginalGMM
{
public:
	PriorBivariateMarginalGMM(VariableSet* varset);
	virtual ~PriorBivariateMarginalGMM();
	
	virtual bool LoadFromXML(const std::string& filename);

	virtual bool EvaluateLogPDF(size_t threadix, const Real* values, Real& logp) const;
	virtual bool Sample(Real* values, RNG* rng) const;
	virtual bool EvaluateMarginalVariance(size_t i, Real& var) const;

private:
	std::vector<std::pair<size_t, size_t> > BivariateGMM_Indices;
	std::vector<std::pair<ETransform, ETransform> > BivariateGMM_Transforms;
	std::vector<BivariateGMM*> BivariateGMMs;
};

}
