#pragma once

#include "Prior.h"
#include "UnivariateMarginal.h"

namespace bcm {

class PriorIndependence : public Prior
{
public:
	PriorIndependence(VariableSet* varset);
	virtual ~PriorIndependence();
	
	bool LoadFromXML(const std::string& filename);
	bool SetMarginal(const std::string& name, UnivariateMarginal* marginal);

	virtual bool EvaluateLogPDF(size_t threadix, const Real* values, Real& logp) const;
	virtual bool Sample(Real* values, RNG* rng) const;
	virtual bool EvaluateMarginalVariance(size_t i, Real& var) const;
	virtual bool EvaluateMarginalCDF(size_t i, const Real value, Real& p) const;
	virtual bool EvaluateMarginalQuantile(size_t i, const Real p, Real& value) const;

private:
	std::vector<UnivariateMarginal*> Variables;
};

}
