#pragma once

namespace bcm {

class RNG;
class Sample;

class SamplePopulation
{
public:
	SamplePopulation();
	~SamplePopulation();

	void Reserve(size_t n_samples, size_t n_variables, size_t n_output);
	
	std::list<Sample*>::iterator GetLowestLLHSample();
	std::list<Sample*>::iterator GetHighestLLHSample();
	std::list<Sample*>::iterator GetRandomSample(RNG* rng);
	std::list<Sample*>::const_iterator GetRandomSample(RNG* rng) const;
	void RemoveSample(std::list<Sample*>::iterator sample);
	Sample* AllocateSample();
	void AddSample(Sample* new_sample);
	void FreeSample(Sample* new_sample);

	std::list<Sample*>::const_iterator cbegin() const;
	std::list<Sample*>::const_iterator cend() const;
	size_t size()  const;

private:
	size_t next_ix;
	size_t num_variables;
	size_t num_output;
	std::vector<Sample*> free_sample_pool;
	std::list<Sample*> samples;
};

}
