#include "Utils.h"
#include "MVNRNG.h"
#include "RNG.h"

namespace bcm {

MVNRNG::MVNRNG()
{
}

MVNRNG::~MVNRNG()
{
}

void MVNRNG::SetCovariance(const MatrixReal& covariance)
{
	CovarianceDecomp = covariance.llt().matrixL();
	Buffer = VectorReal::Zero(covariance.cols());
}

void MVNRNG::Get(RNG* rng, VectorReal& sample)
{
	size_t N = Buffer.size();

	ASSERT(sample.size() == N);

	for (size_t i = 0; i < N; i++) {
		Buffer(i) = rng->GetNormal(0.0, 1.0);
	}

	sample = CovarianceDecomp * Buffer;
}

}
