#pragma once

namespace bcm {
	
Real PdfBeta(Real x, Real a, Real b);
Real PdfExponential(Real x, Real lambda);
Real PdfGamma(Real x, Real shape, Real scale);
Real PdfNormal(Real x, Real mu, Real sigma);
Real PdfT(Real x, Real mu, Real sigma, Real nu);
Real PdfT(Real x, Real mu, Real sigma, Real nu, Real C);

Real LogPdfExponential(Real x, Real lambda);
Real LogPdfNormal(Real x, Real mu, Real sigma);
Real LogPdfT(Real x, Real mu, Real sigma, Real nu, bool skip_na = false);
Real LogPdfT(Real x, Real mu, Real sigma, Real nu, Real logC, bool skip_na = false);
Real LogPdfT_CalcC(Real sigma, Real nu);

Real CdfBeta(Real x, Real a, Real b);
Real CdfCauchy(Real x, Real scale);
Real CdfExponential(Real x, Real lambda);
Real CdfGamma(Real x, Real shape, Real scale);
Real CdfHalfCauchy(Real x, Real scale);
Real CdfNormal(Real x, Real mu, Real sigma);

Real QuantileBeta(Real p, Real a, Real b);
Real QuantileExponential(Real p, Real lambda);
Real QuantileGamma(Real p, Real shape, Real scale);
Real QuantileHalfCauchy(Real p, Real scale);
Real QuantileNormal(Real p, Real mu, Real sigma);
Real QuantileUniform(Real p, Real a, Real b);

}
