#include "Utils.h"
#include "RNG_SFMT.h"

#define HAVE_SSE2
#define DSFMT_DO_NOT_USE_OLD_NAMES
#define DSFMT_MEXP 19937
#undef UINT64_C
extern "C" {
	#include "../../dependencies/dSFMT-src-2.2.2/dSFMT.h"
}
#include "../../dependencies/dSFMT-src-2.2.2/dSFMT.c"

namespace bcm {

RNG_SFMT::RNG_SFMT(unsigned long seed)
	: state((DSFMT_T*)_aligned_malloc(sizeof(DSFMT_T), 16))
{
	Seed(seed);
}

RNG_SFMT::~RNG_SFMT()
{
	_aligned_free(state);
}

void RNG_SFMT::Seed(unsigned long seed)
{
	dsfmt_init_gen_rand(state, seed);
}

unsigned long RNG_SFMT::GetInt()
{
	return dsfmt_genrand_uint32(state);
}

Real RNG_SFMT::GetReal()
{
	return dsfmt_genrand_close1_open2(state) - 1.0;
}

}
