#pragma once

#define _CRT_SECURE_NO_WARNINGS
#define _SCL_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include "Platform.h"

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#if PLATFORM_MACOSX
	#include <malloc/malloc.h>
#else
	#include <malloc.h>
#endif

#include <vector>
#include <list>
#include <set>
#include <queue>
#include <map>
#include <algorithm>
#include <limits>
#include <string>
#include <fstream>
#include <functional>

#include <boost/version.hpp>
#include <boost/foreach.hpp>
#include <boost/property_tree/ptree.hpp>
#include <boost/thread.hpp>

#include <xmmintrin.h>

#include "Debug.h"

#if PLATFORM_WINDOWS && BUILD_DEBUG
	#define EIGEN_RUNTIME_NO_MALLOC
#endif
#include <Eigen/Dense>

#include "Typedefs.h"
#include "Logger.h"
#include "MathFunctions.h"
#include "Timer.h"

namespace bcm {

void tokenize(std::string str, std::vector<std::string>& tokens, const char* delims);
void fix_path(std::string& path);

template<typename T>
inline void safe_delete(T*& ptr)
{
	if (ptr) {
		delete ptr;
		ptr = NULL;
	}
}

template<typename T>
inline void safe_delete_array(T*& ptr)
{
	if (ptr) {
		delete [] ptr;
		ptr = NULL;
	}
}

template<typename T>
inline void safe_aligned_free(T*& ptr)
{
	if (ptr) {
		_aligned_free(ptr);
		ptr = NULL;
	}
}

}
