#include "Utils.h"
#include <boost/test/unit_test.hpp>

#include "VectorUtils.h"

BOOST_AUTO_TEST_CASE(MathFunctions_sort)
{
	VectorReal x;
	x.resize(4);
	x[0] = 2.3;
	x[1] = 2.2;
	x[2] = 10.0;
	x[3] = 0.4;
	VectorReal y = x;
	bcm::sort(y);
	BOOST_CHECK_EQUAL(y[0], x[3]);
	BOOST_CHECK_EQUAL(y[1], x[1]);
	BOOST_CHECK_EQUAL(y[2], x[0]);
	BOOST_CHECK_EQUAL(y[3], x[2]);

	x[2] = std::numeric_limits<Real>::quiet_NaN();
	y = x;
	bcm::sort(y);
	BOOST_CHECK(!(y[1] < x[0]));
	BOOST_CHECK(!(y[2] < x[1]));
	BOOST_CHECK(!(y[3] < x[2]));
}
